<?php
/**
 * Plugin Name: Simple Fonts Loader
 * Plugin URI: https://simpleplugins.fr/sfl/
 * Description: Just enable some fonts from Google Fonts on Website
 * Version: 1.0
 * Author: Tom Baumgarten
 * Author URI: https://www.tombgtn.fr/
 * Text Domain: simple-fonts-loader
 * License: GPL2
 */

if ( ! defined( 'ABSPATH' ) ) exit;

if ( ! defined( 'SIMPLE_FONTS_LOADER_FILE' ) ) define( 'SIMPLE_FONTS_LOADER_FILE', __FILE__ );

require( dirname(SIMPLE_FONTS_LOADER_FILE) . '/includes/fonts.php' );
require( dirname(SIMPLE_FONTS_LOADER_FILE) . '/includes/helper.php' );

if (is_admin()) {
	require( dirname(SIMPLE_FONTS_LOADER_FILE) . '/includes/admin/admin.php' );
} else {
	require( dirname(SIMPLE_FONTS_LOADER_FILE) . '/includes/front/front.php' );
}


/* Chargement des fonts */
foreach ( scandir( dirname(SIMPLE_FONTS_LOADER_FILE) . '/fonts' ) as $dirname ) {

	$dirpath = dirname(SIMPLE_FONTS_LOADER_FILE) . '/fonts/' . $dirname;
	
	if ($dirname!=='.' && $dirname!=='..' && !is_file($dirpath)) {
		$slug = strtolower($dirname);
		$label = ucfirst(strtolower($dirname));
		$category = 'sans-serif';
		if (file_exists($dirpath . '/config.json')) {
			$config = file_get_contents($dirpath . '/config.json');
			if ($config) {
				$config_json = json_decode($config);
				if (is_object($config_json)) {
					if (isset($config_json->label)) $label = strval($config_json->label);
					if (isset($config_json->category)) $category = strval($config_json->category);
				}
			}
		}

		register_font_family($slug, $label, $category);

		foreach ( scandir( $dirpath ) as $filename ) {

			$path = $dirpath . '/' . $filename;

			if ($filename!=='.' && $filename!=='..' && $filename!=='config.json' && is_file($path)) {
				$filename_parts = explode('.', $filename);
				$fonts_parts = explode('-', $filename_parts[0]);
				$url = plugin_dir_url(SIMPLE_FONTS_LOADER_FILE) . 'fonts/' . $dirname . '/' . $filename;
				$weight = (isset($fonts_parts[0])) ? intval($fonts_parts[0]) : 400 ;
				$variant = (isset($fonts_parts[1])) ? strval($fonts_parts[1]) : 'normal' ;
				register_font(strtolower($dirname), $url, $weight, $variant);
			}
		}
	}
}
